/*
Copyright 2022 The orchest Authors.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/orchest/orchest/services/orchest-controller/pkg/apis/orchest/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOrchestClusters implements OrchestClusterInterface
type FakeOrchestClusters struct {
	Fake *FakeOrchestV1alpha1
	ns   string
}

var orchestclustersResource = schema.GroupVersionResource{Group: "orchest.io", Version: "v1alpha1", Resource: "orchestclusters"}

var orchestclustersKind = schema.GroupVersionKind{Group: "orchest.io", Version: "v1alpha1", Kind: "OrchestCluster"}

// Get takes name of the orchestCluster, and returns the corresponding orchestCluster object, and an error if there is any.
func (c *FakeOrchestClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.OrchestCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(orchestclustersResource, c.ns, name), &v1alpha1.OrchestCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OrchestCluster), err
}

// List takes label and field selectors, and returns the list of OrchestClusters that match those selectors.
func (c *FakeOrchestClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.OrchestClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(orchestclustersResource, orchestclustersKind, c.ns, opts), &v1alpha1.OrchestClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.OrchestClusterList{ListMeta: obj.(*v1alpha1.OrchestClusterList).ListMeta}
	for _, item := range obj.(*v1alpha1.OrchestClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested orchestClusters.
func (c *FakeOrchestClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(orchestclustersResource, c.ns, opts))

}

// Create takes the representation of a orchestCluster and creates it.  Returns the server's representation of the orchestCluster, and an error, if there is any.
func (c *FakeOrchestClusters) Create(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.CreateOptions) (result *v1alpha1.OrchestCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(orchestclustersResource, c.ns, orchestCluster), &v1alpha1.OrchestCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OrchestCluster), err
}

// Update takes the representation of a orchestCluster and updates it. Returns the server's representation of the orchestCluster, and an error, if there is any.
func (c *FakeOrchestClusters) Update(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.UpdateOptions) (result *v1alpha1.OrchestCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(orchestclustersResource, c.ns, orchestCluster), &v1alpha1.OrchestCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OrchestCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeOrchestClusters) UpdateStatus(ctx context.Context, orchestCluster *v1alpha1.OrchestCluster, opts v1.UpdateOptions) (*v1alpha1.OrchestCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(orchestclustersResource, "status", c.ns, orchestCluster), &v1alpha1.OrchestCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OrchestCluster), err
}

// Delete takes name of the orchestCluster and deletes it. Returns an error if one occurs.
func (c *FakeOrchestClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(orchestclustersResource, c.ns, name, opts), &v1alpha1.OrchestCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOrchestClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(orchestclustersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.OrchestClusterList{})
	return err
}

// Patch applies the patch and returns the patched orchestCluster.
func (c *FakeOrchestClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.OrchestCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(orchestclustersResource, c.ns, name, pt, data, subresources...), &v1alpha1.OrchestCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OrchestCluster), err
}
